Index: /branches/2015/dev_r5044_CNRS_LIM3CLEAN/NEMOGCM/CONFIG/SHARED/namelist_ice_lim3_ref
===================================================================
--- /branches/2015/dev_r5044_CNRS_LIM3CLEAN/NEMOGCM/CONFIG/SHARED/namelist_ice_lim3_ref	(revision 5070)
+++ /branches/2015/dev_r5044_CNRS_LIM3CLEAN/NEMOGCM/CONFIG/SHARED/namelist_ice_lim3_ref	(revision 5071)
@@ -13,4 +13,7 @@
 &namicerun     !   Generic parameters
 !------------------------------------------------------------------------------
+   jpl            =    5           !  number of ice  categories
+   nlay_i         =    2           !  number of ice  layers
+   nlay_s         =    1           !  number of snow layers (only 1 is working)
    cn_icerst_in  = "restart_ice"   !  suffix of ice restart name (input)
    cn_icerst_out = "restart_ice"   !  suffix of ice restart name (output)
@@ -35,12 +38,9 @@
    rn_smi_ini_s   =  6.3           !        "            "             South
    rn_tmi_ini_n   =  270.          !  initial ice/snw temperature (K), North
-   rn_tmi_ini_s   =  270.          !        "            "              South
+   rn_tmi_ini_s   =  270.          !        "            "             South
 /
 !------------------------------------------------------------------------------
 &namiceitd     !   Ice discretization
 !------------------------------------------------------------------------------
-   jpl            =    5           !  number of ice  categories
-   nlay_i         =    2           !  number of ice  layers
-   nlay_s         =    1           !  number of snow layers (only 1 is working)
    nn_catbnd      =    1           !  computation of ice category boundaries based on
                                    !      1: tanh function
@@ -51,8 +51,9 @@
 &namicedyn     !   Ice dynamics and transport
 !------------------------------------------------------------------------------
-   nn_icestr      =    0           !  ice strength parameteriztaion                          !MV, replaces ridge_scheme_swi
+   nn_icestr      =    0           !  ice strength parameteriztaion                      
                                    !     0: Hibler_79     P = pstar*<h>*exp(-c_rhg*A)
                                    !     1: Rothrock_75   P = Cf*coeff*integral(wr.h^2)    
-   nn_icestr_bvf  =    0           !  ice strength function brine volume (1) or not (0)      !MV replaces brinstren_swi
+   ln_icestr_bvf  =    .false.     !  ice strength function brine volume (T) or not (F)     
+   rn_pe_rdg      =   17.0         !  ridging work divided by pot. energy change in ridging, if nn_icestr = 1
    rn_pstar       =    2.0e+04     !  ice strength thickness parameter (N/m2), nn_icestr = 0 
    rn_crhg        =   20.0         !  ice strength conc. parameter (-), nn_icestr = 0       
@@ -63,8 +64,8 @@
    rn_relast      =    0.333       !  ratio of elastic timescale to ice time step: Telast = dt_ice * rn_relast 
                                    !     advised value: 1/3 (rn_nevp=120) or 1/9 (rn_nevp=300)
-!   nn_ahi0        =    2           !  horizontal diffusivity computation ! MV only 2 is coded now
-!                                   !     0: use rn_ahi0_ref
-!                                   !     1: use rn_ahi0_ref . mean grid cell length / ( 2deg mean grid cell length )
-!                                   !     2: use rn_ahi0_ref . grid cell length      / ( 2deg mean grid cell length )
+   nn_ahi0        =    2           !  horizontal diffusivity computation
+                                   !     0: use rn_ahi0_ref
+                                   !     1: use rn_ahi0_ref x mean grid cell length / ( 2deg mean grid cell length )
+                                   !     2: use rn_ahi0_ref x grid cell length      / ( 2deg mean grid cell length )
    rn_ahi0_ref    = 350.0          !  horizontal sea ice diffusivity (m2/s) 
                                    !     if nn_ahi0 > 0, rn_ahi0_ref is the reference value at a nominal 2 deg resolution
@@ -74,5 +75,5 @@
 !------------------------------------------------------------------------------
    rn_hnewice  = 0.1               !  thickness for new ice formation in open water (m)
-   nn_frazil   = 0                 !  use frazil ice collection thickness as a function of wind (1.0) or not (0.0)
+   ln_frazil   = .false.           !  use frazil ice collection thickness as a function of wind (T) or not (F)
    rn_maxfrazb = 0.0               !  maximum fraction of frazil ice collecting at the ice base
    rn_vfrazb   = 0.417             !  thresold drift speed for frazil ice collecting at the ice bottom (m/s)
@@ -110,5 +111,4 @@
 &namiceitdme   !   Ice mechanical redistribution (ridging and rafting)
 !------------------------------------------------------------------------------
-   rn_pe_rdg   =   17.0            !  ridging work divided by pot. energy change in ridging, nn_ice str = 1 ! MV replaces Cf
    rn_Cs       =   0.5             !  fraction of shearing energy contributing to ridging
    rn_fsnowrdg =   0.5             !  snow volume fraction that survives in ridging
@@ -120,6 +120,6 @@
    rn_astar    =   0.05            !  exponential measure of ridging ice fraction (nn_partfun = 1)
    rn_hstar    = 100.0             !  determines the maximum thickness of ridged ice (m) (Hibler, 1980)
-   nn_rafting  =   1               !  rafting activated (1) or not (0)
-   rn_hraft    =   0.75            !  threshold thickness for rafting (m) !MV replaces h_parmeter
+   ln_rafting  =   .true.          !  rafting activated (T) or not (F)
+   rn_hraft    =   0.75            !  threshold thickness for rafting (m)
    rn_craft    =   5.0             !  squeezing coefficient used in the rafting function
    rn_por_rdg  =   0.3             !  porosity of newly ridged ice (Lepparanta et al., 1995)