Index: branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/Fadd_keys.sh
===================================================================
--- branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/Fadd_keys.sh	(revision 4668)
+++ branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/Fadd_keys.sh	(revision 5086)
@@ -33,6 +33,6 @@
 #
 #
-# Script to add a set off key when compiling a configuration.
-# The list off key to be added has to be enclosed with " ". 
+# Script to add a set of key when compiling a configuration.
+# The list of key to be added has to be enclosed with " ". 
 # A 'sed' is performed to modify the CONFIG_NAME/cpp.fcm file to    
 # add the new key(s). 
Index: branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/Fcheck_config.sh
===================================================================
--- branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/Fcheck_config.sh	(revision 4668)
+++ branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/Fcheck_config.sh	(revision 5086)
@@ -39,5 +39,5 @@
 # - Nothing set, use the previous in use 
 #
-# We use TOOLS/CONFIG_DIR/cfg.txt to check if the onfiguration exists.
+# We use TOOLS/CONFIG_DIR/cfg.txt to check if the configuration exists.
 #
 # EXAMPLES
@@ -76,5 +76,5 @@
    echo "Use makenemo -n MYCONFIG"
    echo "or  makenemo -h for help"
-   echo "Using defaut configuration : ${NEW_CONF}"
+   echo "Using default configuration : ${NEW_CONF}"
 fi
 if [ "$1" == cfg.txt ]; then
Index: branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/Fclean_var.sh
===================================================================
--- branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/Fclean_var.sh	(revision 4668)
+++ branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/Fclean_var.sh	(revision 5086)
@@ -11,5 +11,5 @@
 #
 # ----------------------------
-# Clean environement variables
+# Clean environment variables
 # ----------------------------
 #
@@ -26,5 +26,5 @@
 #
 #
-# Clean environement variables
+# Clean environment variables
 #
 # EXAMPLES
Index: branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/Fcopy_dir.sh
===================================================================
--- branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/Fcopy_dir.sh	(revision 4668)
+++ branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/Fcopy_dir.sh	(revision 5086)
@@ -26,5 +26,5 @@
 #
 #
-# When a refenrence configuration is set, 
+# When a reference configuration is set, 
 # Copy NEMO sub-directories needed (OPA_SRC, TOP_SRC ...)
 #
Index: branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/Fcopy_extdir.sh
===================================================================
--- branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/Fcopy_extdir.sh	(revision 5086)
+++ branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/Fcopy_extdir.sh	(revision 5086)
@@ -0,0 +1,39 @@
+#!/bin/bash
+#set -x
+set -o posix
+#set -u
+#set -e
+#+
+# ============
+# Fcopy_extdir.sh
+# ============
+# --------------------------
+# Copy a reference directory
+# --------------------------
+# SYNOPSIS
+# ========
+# ::
+#  $ Fcopy_extdir.sh
+# DESCRIPTION
+# ===========
+# When an unsupported configuration is requested, 
+# Prepare sources for the NEMO sub-directories needed (OPA_SRC, TOP_SRC ...)
+# EXAMPLES
+# ========
+# ::
+#  $ ./Fcopy_extdir.sh ORCA2_LIM
+# TODO
+# ====
+# option debug
+# EVOLUTIONS
+# ==========
+# $Id: Fcopy_extdir.sh 3294 2012-01-28 16:44:18Z rblod $
+#   * creation
+#-
+grep "$1 " ${CONFIG_DIR}/uspcfg.txt > ${CONFIG_DIR}/cfg.tmp
+#
+LOCAL_REF=$(cat cfg.tmp | awk 'BEGIN {FS = "#" }{print $2}')
+TAB=$(cat cfg.tmp | awk 'BEGIN {FS = "#" }{print $3}')
+REMOTE_CTL=$(cat cfg.tmp | awk 'BEGIN {FS = "#" }{print $4}')
+#
+\rm ${CONFIG_DIR}/cfg.tmp
Index: branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/Fdel_keys.sh
===================================================================
--- branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/Fdel_keys.sh	(revision 4668)
+++ branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/Fdel_keys.sh	(revision 5086)
@@ -34,5 +34,5 @@
 #
 # Add cpp keys when compiling a configuration, key list has to be enclosed with " ".
-# We perform a 'sed' on the CONFIG_NAME/CPP.fcm file, contianing the list of keys. 
+# We perform a 'sed' on the CONFIG_NAME/CPP.fcm file, containing the list of keys. 
 #
 # EXAMPLES
Index: branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/Ffetch_extdir.sh
===================================================================
--- branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/Ffetch_extdir.sh	(revision 5086)
+++ branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/Ffetch_extdir.sh	(revision 5086)
@@ -0,0 +1,53 @@
+#!/bin/bash
+#set -x
+set -o posix
+#set -u
+#set -e
+#+
+# ===============
+# Ffetch_extdir.sh
+# ===============
+# ---------------
+# Make the config 
+# ---------------
+# SYNOPSIS
+# ========
+# ::
+#  $ Ffetch_extdir.sh
+# DESCRIPTION
+# ===========
+# - Make the config directory 
+# - Create repositories needed :
+#  
+#  - EXP00 for namelist
+#  - MY_SRC for user sources
+#  - BLD for compilation 
+# EXAMPLES
+# ========
+# ::
+#  $ ./Ffetch_extdir.sh CONFIG_NAME REMOTE_CTL 
+# TODO
+# ====
+# option debug
+# EVOLUTIONS
+# ==========
+# $Id: Ffetch_extdir.sh 3715 2012-11-28 16:06:02Z acc $
+#   * creation
+#-
+basedir=$(pwd)
+cd ${1}
+wget ${2} -O remote_file.list
+#
+if [ -f remote_file.list ] ; then
+ cat remote_file.list | grep -v '^#' |
+  while
+   read remfile locfile
+   do
+    if [ $remfile == 'create_directory' ] ;then
+      mkdir $locfile
+    else
+      wget $remfile -O $locfile
+    fi
+   done
+fi
+cd $basedir
Index: branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/Fmake_WORK.sh
===================================================================
--- branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/Fmake_WORK.sh	(revision 4668)
+++ branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/Fmake_WORK.sh	(revision 5086)
@@ -35,5 +35,5 @@
 # Make the WORK directory:
 #
-# - Create lin in NEW_CONF/WORK
+# - Create line in NEW_CONF/WORK
 # - Use specified sub-directories previously
 # - OPA has to be done first !!!
Index: branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/Fmake_extconfig.sh
===================================================================
--- branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/Fmake_extconfig.sh	(revision 5086)
+++ branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/Fmake_extconfig.sh	(revision 5086)
@@ -0,0 +1,48 @@
+#!/bin/bash
+#set -x
+set -o posix
+#set -u
+#set -e
+#+
+# ===============
+# Fmake_extconfig.sh
+# ===============
+# ---------------
+# Make the directories for an externally supported configuration
+# and base the initial versions on the nearest equivalent from the
+# reference set (as named in uspcfg.txt)
+# ---------------
+# SYNOPSIS
+# ========
+# ::
+#  $ Fmake_extconfig.sh
+# DESCRIPTION
+# ===========
+# - Make the config directory 
+# - Create repositories needed :
+#  - EXP00 for namelist
+#  - MY_SRC for user sources
+#  - BLD for compilation 
+# EXAMPLES
+# ========
+# ::
+#  $ ./Fmake_extconfig.sh CONFIG_NAME REF_CONFIG_NAME 
+# TODO
+# ====
+# option debug
+# EVOLUTIONS
+# ==========
+# $Id: Fmake_extconfig.sh 3715 2012-11-28 16:06:02Z acc $
+#   * creation
+#-
+\mkdir  ${1}
+\mkdir  ${1}/EXP00
+\mkdir  ${1}/MY_SRC
+\cp -R  ${2}/cpp_${2}.fcm ${1}/cpp_${1}.fcm
+\cp -R  ${2}/EXP00/*namelist* ${1}/EXP00/.
+[ -f ${2}/EXP00/AGRIF_FixedGrids.in ] &&  \cp -R  ${2}/EXP00/AGRIF_FixedGrids.in ${1}/EXP00/.
+[ -f ${2}/EXP00/iodef.xml ]           &&  \cp -R  ${2}/EXP00/iodef.xml ${1}/EXP00/.
+[ -f ${2}/EXP00/field_def.xml ]       &&  \cp -R  ${2}/EXP00/field_def.xml ${1}/EXP00/.
+[ -f ${2}/EXP00/domain_def.xml ]      &&  \cp -R  ${2}/EXP00/domain_def.xml ${1}/EXP00/.
+[ -f ${2}/EXP00/xmlio_server.def ]    &&  \cp -R  ${2}/EXP00/xmlio_server.def ${1}/EXP00/.
+[ -d    ${2}/MY_SRC ]                 &&  \cp  ${2}/MY_SRC/* ${1}/MY_SRC/. 2> /dev/null
Index: branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/bld.cfg
===================================================================
--- branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/bld.cfg	(revision 4668)
+++ branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/bld.cfg	(revision 5086)
@@ -24,4 +24,6 @@
 
 
+bld::tool::cpp       %CPP
+bld::tool::fpp       %CPP
 bld::tool::fc        %FC 
 bld::tool::fflags    %FCFLAGS %USER_INC
@@ -51,10 +53,5 @@
 bld::excl_dep        inc::mpe_logf.h
 bld::excl_dep        use::mpi
-bld::excl_dep        use::mod_prism_proto
-bld::excl_dep        use::mod_prism_def_partition_proto
-bld::excl_dep        use::mod_prism_get_comm
-bld::excl_dep        use::mod_prism_get_proto
-bld::excl_dep        use::mod_prism_put_proto
-bld::excl_dep        use::mod_comprism_proto
+bld::excl_dep        use::mod_oasis
 bld::excl_dep        use::mkl_dfti
 # Don't generate interface files
Index: branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/bld_preproagr.cfg
===================================================================
--- branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/bld_preproagr.cfg	(revision 4668)
+++ branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/bld_preproagr.cfg	(revision 5086)
@@ -34,5 +34,6 @@
 bld::pp::nemo     1
 bld::pp::nemo/agrif2model     0
-bld::tool::fpp       cpp
+bld::tool::cpp       %CPP
+bld::tool::fpp       %CPP
 bld::tool::fppflags::nemo  %FPPFLAGS
 
@@ -46,10 +47,5 @@
 bld::excl_dep        inc::mpe_logf.h
 bld::excl_dep        use::mpi
-bld::excl_dep        use::mod_prism_proto
-bld::excl_dep        use::mod_prism_def_partition_proto
-bld::excl_dep        use::mod_prism_get_comm
-bld::excl_dep        use::mod_prism_get_proto
-bld::excl_dep        use::mod_prism_put_proto
-bld::excl_dep        use::mod_comprism_proto
+bld::excl_dep        use::mod_oasis
 bld::excl_dep        use::mkl_dfti
 bld::excl_dep	     use::nc4interface
Index: branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/bld_tools.cfg
===================================================================
--- branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/bld_tools.cfg	(revision 4668)
+++ branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/bld_tools.cfg	(revision 5086)
@@ -16,4 +16,6 @@
 dir::root            $NEMO_TDIR/$NEW_CONF/BLD
 
+bld::tool::cpp       %CPP
+bld::tool::fpp       %CPP
 bld::tool::fc        %FC 
 bld::tool::fflags    %FCFLAGS %USER_INC
Index: branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/bldxag.cfg
===================================================================
--- branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/bldxag.cfg	(revision 4668)
+++ branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/COMPILE/bldxag.cfg	(revision 5086)
@@ -23,4 +23,6 @@
 
 
+bld::tool::cpp       %CPP
+bld::tool::fpp       %CPP
 bld::tool::fc        %FC 
 bld::tool::fflags    %FCFLAGS %USER_INC
@@ -47,10 +49,5 @@
 bld::excl_dep        inc::mpe_logf.h
 bld::excl_dep        use::mpi
-bld::excl_dep        use::mod_prism_proto
-bld::excl_dep        use::mod_prism_def_partition_proto
-bld::excl_dep        use::mod_prism_get_comm
-bld::excl_dep        use::mod_prism_get_proto
-bld::excl_dep        use::mod_prism_put_proto
-bld::excl_dep        use::mod_comprism_proto
+bld::excl_dep        use::mod_oasis
 bld::excl_dep        use::mkl_dfti
 # Don't generate interface files